<script setup lang="ts">
    import { VRow } from "vuetify/components";
    import { Coordinate } from "./../functions/types";
    import { computed, onMounted, onUnmounted, ref } from "vue";
    import { closeEnoughToAnySafePoint } from "../functions/safezone";
    import toastr from "toastr";

    const props = defineProps<{
        currentCoordinate: Coordinate;
    }>();
    const emit = defineEmits(["closePhotoApplication", "uploadPhoto"]);

    function close() {
        emit("closePhotoApplication");
    }

    // !!! CAMERA

    const storageKey = "signupCameraRotation";
    let stream = null as MediaStream | null;

    const image = ref(null as null | string);
    const hasImage = computed(() => {
        return image.value != null && image.value.length > 50;
    });

    const hasCamera = ref(false);

    const facingMode = ref((localStorage.getItem(storageKey) ?? "environment") as "environment" | "user");

    // Access the user's camera
    async function initCamera() {
        console.log("Initializing Camera");
        hasCamera.value = false;
        try {
            stream = await navigator.mediaDevices.getUserMedia({
                video: {
                    facingMode: facingMode.value,
                },
            });
            const video = document.getElementById("video") as HTMLVideoElement;
            if (video != null) {
                video.srcObject = stream;
            } else {
                console.log("Did not find Video HTML element");
            }

            hasCamera.value = true;
        } catch (err) {
            console.error("Error accessing the camera:", err);
            hasCamera.value = false;
        }
    }

    // Take a picture
    function takePicture() {
        const canvas = document.getElementById("canvas") as HTMLCanvasElement;
        const video = document.getElementById("video") as HTMLVideoElement;
        const context = canvas.getContext("2d");
        // Set canvas dimensions to the same as the video
        canvas.width = video.videoWidth;
        canvas.height = video.videoHeight;
        // Draw the current frame of the video onto the canvas
        context?.drawImage(video, 0, 0, canvas.width, canvas.height);
        // Get the image data from the canvas as a base64-encoded PNG
        const imageData = canvas.toDataURL("image/png");

        image.value = imageData;
    }

    // Toggle the direction of the camera
    function toggleCameraFaceingness() {
        if (facingMode.value == "environment") {
            facingMode.value = "user";
        } else {
            facingMode.value = "environment";
        }
        console.log("toggled to facing " + facingMode.value);
        localStorage.setItem(storageKey, facingMode.value);

        initCamera();
    }

    function removePhoto() {
        image.value = null;
    }

    function uploadPhoto() {
        const closeEnough = closeEnoughToAnySafePoint(props.currentCoordinate[0], props.currentCoordinate[1]);

        if (closeEnough) {
            emit("uploadPhoto", image.value);
            image.value = null;
        } else {
            toastr.error("Außerhalb vom App-Einsatzgebiet kann nichts hochgeladen werden");
        }
    }

    onMounted(() => {
        initCamera();
    });
    onUnmounted(() => {
        if (stream) {
            stream.getTracks().forEach(function (track) {
                track.stop();
            });
        }
    });
</script>

<template>
    <v-row justify="center" style="color: white">
        <div>
            <p>Achtung!! Fotos die mit dieser Funktion geschossen werden,</p>
            <p>werden zusammen mit dem Standort {{ props.currentCoordinate }}</p>
            <p>auf einem Server des Mathezirkel hochgeladen!!</p>
        </div>
    </v-row>

    <div>
        <v-row justify="center">
            <v-row id="camera-button-container" class="v-col-12 v-col-xl-4 v-col-lg-6 v-col-md-8 v-col-sm-10 mt-3">
                <template v-if="hasImage">
                    <img id="image" :src="image ?? ''" class="v-col-12" />
                    <v-btn @click="removePhoto" icon="mdi-delete" id="abort-btn"> </v-btn>
                    <v-btn @click="uploadPhoto" icon="mdi-upload" id="upload-btn"> </v-btn>
                </template>

                <video
                    id="video"
                    class="v-col-12"
                    autoplay
                    :style="{ display: (!hasCamera || hasImage) ?? false ? 'none' : 'revert' }"
                    playsinline
                ></video>

                <template v-if="!hasImage">
                    <div class="v-col-12" id="video-replacement" v-if="!hasCamera">
                        <p class="mt-8">Kamera nicht verfügbar.</p>
                        <p>Eventuell fehlt die Freigabe / Berechtigung</p>
                    </div>
                    <button id="capture-btn" v-on:click="takePicture"></button>
                    <v-btn id="reverse-btn" icon="mdi-camera-switch" v-on:click="toggleCameraFaceingness"></v-btn>
                </template>
            </v-row>
        </v-row>
        <canvas style="display: none" id="canvas"></canvas>
    </div>

    <div id="close-photo-mode">
        <v-btn icon="mdi-close" @click="close()"></v-btn>
    </div>
</template>

<style scoped>
    #close-photo-mode {
        position: absolute;
        right: 2em;
        bottom: 1em;
    }
    #video {
        width: 100%;
    }
    #image {
        width: 100%;
    }
    #video-replacement {
        width: 100%;
        aspect-ratio: 1 / 1;
        background-color: gray;
    }
    #camera-button-container {
        position: relative;
    }
    #capture-btn {
        background-color: red;
        position: absolute;
        width: 4em;
        height: 4em;
        border-radius: 50%;
        border: 0.5em black solid;
        bottom: 2%;
        left: 50%;
        transform: translate(-50%, -50%);
        z-index: 10; /* Ensure the button is above the video */
    }
    #reverse-btn {
        position: absolute;
        bottom: 2%;
        right: 2%;
        transform: translate(-50%, -50%);
        z-index: 10;
    }
    #abort-btn {
        position: absolute;
        bottom: 2%;
        left: 45%;
        transform: translate(-50%, -50%);
    }
    #upload-btn {
        position: absolute;
        bottom: 2%;
        left: 45%;
        transform: translate(+100%, -50%);
        background-color: green;
    }
</style>
